/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : August. 2006

 File          : main.c, I2C_Functions.c, I2C_Functions.h

 Hardware      : ADuC702x Rev I silicon, MicroChip 24LC128

                  ADuC702x        ->      24LC128
                  P1.2  ( SCL )           SCL     ( Pin 6 )
                  P1.3  ( SDA )           SDA     ( Pin 5 )
                  P3.2                    WP      ( Pin 7 )

                 24LC128 Write Address = 0xA0
                 24LC128 Read  Address = 0xA1

 Description   : Example program for integration of MicroChip 24LC128
                 I2C Serial EEPROM Module.

                 8 Bytes of data are written to the Serial EEPROM and 
                 then read back.

*********************************************************************/

/* Place Include files here */

#include "ioADuC7026.h"
#include "I2CFunctions.h"

// Place Function Prototypes here

void Init_ADuC7024(void);

// Place Global Variables here

// Main Function

int main()
{
    // Place local variable definitions here
    unsigned char c_data_in[8],c_data_out[8],c_temp;
    int i;
    
    
    // Initialise dummy data
    
    for ( i = 0; i < 8  ; i++)
    {
        c_data_in[i] = i;
    }   

   Init_ADuC7024();           // Configure ADuC
   
 //  Page_Write(0,c_data_in,8); // Write Data to Serial EEPROM
  c_temp =  Byte_Read(3);    // Read A Single Byte
   i = Read_Current_Address();// Read Current Address Counter
  
   i = Read_Current_Address();// Read Current Address Counter
   
  Byte_Read_8(0,c_data_out,8); // Write Data to Serial EEPROM
   i = Read_Current_Address();// Read Current Address Counter
   i = Read_Current_Address();// Read Current Address Counter   
  while(1)
  {}
}

// Configure PLL Divider, GPIO and I2C for 100kHz Operation

void Init_ADuC7024(void)
{
    POWKEY1   =   0x1;
    POWCON    =   0x00;   //  Configure Core operation for CD = 0
    POWKEY2   =   0xf4;

    GP1CON = 0x2200;	  // I2C on P1.2 and P1.3

    I2C1CFG = 0x82;	  // Master Enable & Enable Generation of Master Clock
	
    // I2C-Master setup
    I2C1DIV = 0xCFCF;	  // 0x3232 = 400kHz
			  // 0xCFCF = 100kHz	


    GP3DAT = 0x04000000;  // Disable HW Write Protection

}
